%!TEX ROOT=thesis.tex

\newacronym{GPS}{GPS}{Global Positioning System}
\newacronym{IR}{IR}{Infra Red}
\newacronym{LED}{LED}{Light Emitting Diode}
\newacronym{ADC}{ADC}{{Analog-Digital Converter}}
\newacronym{IO}{IO}{{Input-Output}}
\newacronym{SPI}{SPI}{Serial Peripheral Interface}
\newacronym{UART}{UART}{Universal Asynchronous Receiver and Transmitter}
\newacronym{I2C}{I2C}{Inter-Integrated Circuit}
\newacronym{MCU}{MCU}{Microcontroller Unit}
\newacronym{LightBed}{LightBed}{Sensing-Acting board}
\newacronym{PCB}{PCB}{Printed Circuit Board}
\newacronym{CS}{CS}{Chip-Select}
\newacronym{MOSFET}{MOSFET}{Metal Oxide Semiconductor Field Effect Transistor}
\newacronym{RMII}{RMII}{Reduced Media Independent Interface}
\newacronym{IDE}{IDE}{Integrated Development Environment}
\newacronym{MAC}{MAC}{Media Access Controller}
\newacronym{UDP}{UDP}{User Datagram Protocol}
\newacronym{PC}{PC}{Personal Computer}
\newacronym{GUI}{GUI}{Graphical User Interface}
\newacronym{SVR}{SVR}{Support Vector Regression}
\newacronym{LIFO}{LIFO}{Last In, First Out}

\chapter{Introduction}
    The main purpose of this thesis is to design a replacement for the single point of failure position detection system — a camera — which is used in the project called MagMan \cite{cite:magman}, or its successor the manipulator which uses non-uniform electric and magnetic fields \cite{cite:parallelManipulation}. The MagMan is a distributed manipulator, which uses several coils to manipulate with objects. Requirement to extend the MagMan platform introduces several constraints, mainly on the physical size of the solution. Restrictions related to the MagMan project are the size of the module, which should not exceed $50 \times 50$\,mm$^2$ and the distance between manipulated items and the MagMan should be as short as possible because MagMan manipulates items using the electromagnetic field and therefore an increasing distance lowers effectivity of the manipulation. Next limitation related to MagMan platform is on a used position detection principle, which should not collide with MagMan controlling mechanism — manipulation using the electromagnetic field, which implies manipulation with ferrous metals.

    We choose a light-based position detection system depending on the intensity of reflected light from the detected item(s) you can see the final measuring board in Figures \ref{fig:lightBedTop} and \ref{fig:lightBedBottom}. This thesis solves related problems and proposes a working hardware solution.

    Outline of this thesis is the state of the art of position detection systems, our designed hardware and software solution, and a description of the experiments we made.

    \begin{figure}[!h]
        \includegraphics[width=1.2\textwidth]{LightBedTop.jpg}
        \caption{The top layer of designed LightBed board}
        \label{fig:lightBedTop}
    \end{figure}

    \begin{figure}[!h]
        \includegraphics[width=1.2\textwidth]{LightBedBottom.jpg}
        \caption{The bottom layer of designed LightBed board}
        \label{fig:lightBedBottom}
    \end{figure}

\chapter{State of the Art}
    Knowledges and existing solutions on position detection problem is summarized in this chapter.

    \section*{Position Detection}
        In the position detection problem, we are generally trying to locate an item or items of known or unknown material and shape in a known coordinate system. There exist several position detection based on several principles with wide advantages and disadvantages.

        Another position detection system exploits 3D-printed magnets to detect position \cite{cite:3Dprintedmagnet} by detecting the modulation of the magnetic field generated by the motion of a ferromagnetic object. Where 3D-printed magnets improve the linearity of the system. The different team uses an ultra‐high frequency microstrip wave antenna \cite{cite:ultraHighFrequencyMicrostrip}, which reads ID tag and its position with precision approximately 1.5\,cm with physical size $95 \times 95$\,mm$^2$.

        Detection of the position can also use light transmitter and emitter arrays, which detects shadow of the measured object. These system needs usually suppress influence of a surrounding light, some project use neural network which needs to be recalibrated with each change of surrounding light conditions, others try to handle need of recalibration with Genetic Programming Technique \cite{cite:lightArray}.

        The interesting project is the LED sensing matrix \cite{cite:ledSensisngMatrix} which uses a matrix of LEDs as an actuator and also as a transmitter. The position detection is based on anode sensing. Therefore it measures surrounding light intensity at a given wavelength.

    \section*{Summary}
        We decided to use light-based sensor primary because it does not collide with the MagMan electromagnetic field. It is also cheap. And it is a distributed solution usable together with the MagMan modules. We decided to use matrix of light sensors and emitters, because this solution can measure 3D scene, and not only 2D as solutions using a light arrays.

\chapter{Designed Solution}
    The proposed solution uses two shifted $8 \times 8$ matrices consisting of \acrfull{IR} \acrfull{LED} and \acrshort{IR} phototransistor. We decide to use \acrshort{IR} light (exactly wavelength 940\,nm) because it is not part of visible light and therefore, people around will not be disturbed by its operation. We choose to use matrix with dimension eight because of straight forward mapping to bytes and thus to existing \acrfull{ADC} and \acrfull{IO} expansion chips. Both \acrshort{IR} \acrshort{LED}s and \acrshort{IR} phototransistor matrices have items distance 6.35\,mm in both axes, the offset of matrices is 3.175\,mm also in both axes. Proposed matrix distance allows extending sensing plane with identical modules in any direction in the same way as the MagMan is permitted to do so. The last physical constraint we use in the design phase is 90$^{\circ}$ rotation of \acrshort{IR} phototransistors against \acrshort{IR} \acrshort{LED}s alignment to minimize direct cross-talk.

    \section*{Hardware}
        We choose to divide designed hardware into two \acrlong{PCB}s (\acrshort{PCB}). The computing board and the \acrfull{LightBed}. The decision to split the proposed solution into two independent board allows us to keep \acrshort{LightBed} board as simple and thin as possible, which was one of our constraints, and also allows independent replacement of parts and their versions independently.

        We use PIC32MZ2048EFH144 \cite{cite:pic32} as per module computation unit. \\PIC32MZ pre-selected for an over-standard number of analog inputs. However, the \acrshort{ADC} circuits of the \acrfull{MCU} are slow and support only six Sample and Hold circuits in comparison to external \acrshort{ADC}. We can use this \acrshort{MCU} anyway because it supports up to 6 \acrshort{SPI} buses, 100\,Mbps Ethernet, several \acrfull{UART}, and \acrfull{I2C} buses and good enough computation power — \acrshort{MCU} is operating on frequency up to 252\,MHz with power supply 3.3V. We choose Microchip's product as a device from a reliable market player, which we already know. We surveyed the market taking in an account also vendors STMicroelectronics and Atmel Corporation.

        We build this solution using a daughter board EasyPIC FUSION v7 with PIC32MZ2048EFH144 \cite{cite:pic32daughter}, which contains the LAN8720A \cite{cite:lan8720a} 100\,Mbps Ethernet Transceiver connected to \acrshort{MCU} through \acrfull{RMII}, enabling us to connect our solution to any device with Ethernet support. With the first power up, it was discovered that polarity of notification \acrshort{LED}s controls the mode of the mentioned LAN chip. The schema sets up LAN chip correctly is in Appendix B, the Figure \ref{fig:rj45Schematics}.

        To fulfill the distributed manners of the solution, we divide the designed \acrshort{LightBed} into four sensing blocks and eight active blocks which can work independently. One sensing block consists of 16 \acrshort{IR} phototransistors connected to \acrshort{ADC}, and each control block consists of 8 \acrshort{IR} \acrshort{LED}s connected to \acrshort{IO} expander. We use MAX11625 \cite{cite:max116}, which is 16 channels, 10-Bit \acrlong{ADC} working up to 300\,ksps, containing 10\,MHz \acrfull{SPI}. As an \acrlong{IO} expander, we use MCP23S09 \cite{cite:mcp23}, which is eight channels controlling chip containing 10\,MHz \acrshort{SPI} interface. We choose those chips because they were in small packages, they provide reasonable speed, and are in current production, which should guarantee a possibility of subsequent works.

        We organize connection between \acrshort{MCU} and \acrshort{LightBed} into 6 \acrshort{SPI} buses (see the Figure \ref{fig:hwCore}). Specifically, we use four buses to connect \acrlong{ADC} separately, which respect distributed constraints and also maintain system performance, and two buses to connect 8 \acrlong{IO} expanders, which is a trade-off between the used number of buses and redundancy. Also, the configuration of the \acrlong{IO} expanders buses with proper software setup (see section Software in this chapter) does not harm the performance of the active part of the board. The first proposed hardware revision uses \acrshort{SPI} Daisy-Chain (see the Figure \ref{fig:daisyChain} \cite{cite:maximDaisyChain}), which lowers a number of used wires by extending the length of communication loop — meaning connecting two 8\,bit \acrshort{SPI} devices the bus become 16\,bit; however, used \acrshort{ADC} and \acrshort{IO} expander chips do not support it. This wrong assumption in the design process does verify that the system is truly distributed and even with such design issue, it is still partially working.

        \begin{figure}[!h]
            \includegraphics[width=1.\textwidth]{HwCore.pdf}
            \caption{\acrshort{MCU} and peripherals connection}
            \label{fig:hwCore}
        \end{figure}

        \begin{figure}[!h]
            \includegraphics[width=1.\textwidth]{daisy-chain.png}
            \caption{SPI Daisy-Chain}
            \label{fig:daisyChain}
        \end{figure}

        You may see from the Figure \ref{fig:hwCore} that sensing parts (MAX11625 \acrshort{ADC}) are as independent as possible, and a group of acting parts (4x MCP23S09 \acrshort{IO} expanders) share the same bus. \acrfull{CS} activates each acting chip, from that you can see that it is not possible to set up different values on \#1 MCP23S09 and \#2 MCP23S09 using one message, it always requires two different messages as they share one \acrshort{SPI} bus.

        We select a pair of matching \acrlong{IR} phototransistor KP-1608P1C \cite{cite:kp1608p1c} and \acrlong{LED} KP-1608F3C \cite{cite:kp1608f3c} as the sensor and the actuator operating on wavelength 940nm, with good spatial distribution, both are cheap and currently available on the market.
        
        We design each sensing part as totally independent on others as it is again fail-resistant as you can see from the Figure \ref{fig:hwTransmitter}, where you can also see circuit converting current flowing through phototransistor — which is related to light intensity — to the voltage on resistor $R_1 = 5.1 \cdot 10^{3}\,\Omega$ referring to Ohm's law \cite{cite:ohm}. The output voltage of phototransistor and resistor pair are for complete darkness $I_{dark} = 0.1 \cdot 10^{-6}\,A$ equals to $$
            U_{R_{1}d} = I_{dark} R_1 = 5.1 \cdot 10^{-4}\,V ,
        $$ and for light intensity $E_e=10\,W/m^2$ equals to IR phototransistor current $I_{E_e} = 0.3 \cdot 10^{-3}\,A$ the output voltage $U_{R_{1}on}$ is then $$
            U_{R_{1}on} = I_{E_e} R_1 =1.53\,V ,
        $$ for such light intensity we have still reserve till circuit saturation, which will behave as $U_{R_{1}}=2.5\,V$. We put a low pass RC filter with cut-off frequency $f_c=99.5 \cdot 10^{3}\,Hz$ between a phototransistor and resistor pair, and an \acrshort{ADC} input pin to maintain the Nyquist-Shannon sampling theorem \cite{cite:shannon}.

        \begin{figure}[!t]
            \includegraphics[width=0.6\textwidth]{HwTransmitter.png}
            \caption{IR phototransistor with low pass RC filter circuit}
            \label{fig:hwTransmitter}
        \end{figure}

        We design a circuit to control the active part of the \acrshort{LightBed} connected to \acrshort{IO} expander also in a distributed way, only to save space on \acrshort{PCB} we use \acrfull{MOSFET} pair in one package. We choose NX3008NBKS \cite{cite:nx3008nbks}, which is dual N-channel Trench MOSFET with worse Gate-Source threshold voltage 1.1\,V, which is possible to control with the 3.3\,V logic supply. We choose pull-up resistor for \acrshort{MOSFET} because selected \acrshort{IO} expander has limited power on pins in the High state, and we choose the value of the resistor $R_2$ as lowest as possible allowed by datasheet of \acrshort{IO} expander concerning maximal flowed current — low value should minimize \acrshort{MOSFET} switch time, current circuit maintains switch time 340\,ns. We configured \acrshort{IR} \acrshort{LED} to use as much power as possible by resistors $R_1$ and $R_3$.

        \begin{figure}[!t]
            \includegraphics[width=1.1\textwidth]{HwEmitter.png}
            \caption{Pair of an IR LED controlling circuits}
            \label{fig:hwEmitter}
        \end{figure}

        We encouraged some issues like crosstalk and ringing during connecting \acrshort{MCU} and \acrshort{LightBed}. We resolve those issues introducing serial resistors on problematic \acrshort{SPI} buses. Also, we found direct light crosstalk between \acrshort{IR} \acrshort{LED} and \acrshort{IR} phototransistor. We suppress light crosstalk by creating the 3D-printed precisely shaped plastic cover for the top layer of a \acrshort{LightBed}, whose 3D model is in the Figure \ref{fig:plasticCover}. We made measurements from the \acrshort{LightBed} board to compare data quality with and without the plastic cover as you can see in Figures \ref{fig:hwBedWithoutCover} and \ref{fig:hwBedWithCover}, where green represents optimal values and each red pixel represents direct crosstalk between \acrshort{IR} \acrshort{LED} and \acrshort{IR} phototransistor, detailed explanation of the figures is in the next section Software.

        \begin{figure}[!h]
            \includegraphics[width=0.8\textwidth]{cover.png}
            \caption{A model of the LightBed plastic cover}
            \label{fig:plasticCover}
        \end{figure}

        \begin{figure}[!h]
            \includegraphics[width=0.8\textwidth]{HwWithoutPlasticCover.png}
            \caption{Light Bed board without the plastic cover}
            \label{fig:hwBedWithoutCover}
        \end{figure}

        \begin{figure}[!h]
            \includegraphics[width=0.8\textwidth]{HwWithPlasticCover.png}
            \caption{Light Bed board with the plastic cover}
            \label{fig:hwBedWithCover}
        \end{figure}

    \section*{Software}
        In this section, we will describe our choices regarding the software part of the solution. Our decisions regarding the software are influenced by hardware, which we choose and explain in the previous section.

        The core part of the solution, the PIC32MZ, can be programmed using Microchip MPLAB C Compiler \cite{cite:mplabC}. Microchip also offers its MPLAB \acrfull{IDE} \cite{cite:mplabX} based on NetBeans \cite{cite:netbeans} project with MPLAB Harmony \cite{cite:mplabHarmony}, which is a development framework providing base drivers and stacks like Ethernet stack or \acrshort{MAC} driver. We use a lot of features supplied by MPLAB Harmony to improve the structure of the application and its abstraction from the hardware. The framework offers way how to write firmware without active waiting on the resources.

        We divide the application into modules with the same scope as hardware modules. Therefore hardware fault will not harm the procedures of still viable parts of the solution. The modules of the application are Time Manager, MCP23 module, MAX116 module, Console manager, Network manager, and Measuring manager (see Algorithm \ref{alg:mcuFirmware}). The Time Manager is supposed to measure precise time in the scale of 10x $\mu s$, which is required for the correct operation of the MCP23 and MAX116 modules. The MCP23 module maintains initialization and effective control of \acrshort{IO} expanders. The MAX116 module sets up \acrshort{ADC} chips and continuously collects measured data. The Console manager configures \acrshort{UART} debug interface, which provides information about states of the application and offers basic maintenance commands. The Measuring manager controls MCP23 and MAX116 cooperation in the way, so they do not cause data loss but still collect all available information from the \acrshort{LightBed} environment. The Network manager holds state updated from the \acrfull{UDP} subscriber server and act as a \acrshort{UDP} client to higher level server, like \acrfull{PC} or the MagMan Raspberry Pi. The UDP protocol was chosen, because it is a simple protocol, and its usage does not bring overhead of the other protocols like the TCP protocol.

        \begin{algorithm}
            \caption{MCU firmware}
            \label{alg:mcuFirmware}

            \SetAlgoLined
            initialization of the global state;

            \While{True }{
                \If{ MAX116 measurement is not active }{
                    Perform MCP23 tasks;
                }

                Perform MAX116 tasks;

                Perform network tasks;

                Perform measuring tasks;
            }

        \end{algorithm}

        The MCP23 module controls hardware in the way that it remembers the last state of the hardware, and request only necessary changes on the SPI bus. Our MCP23 driver can change the whole state of the active parts of the LightBed in 3\, bytes, so the shortest time to change state of the LightBed board is $2.4 \cdot 10^{-6}\,s$. We use the existence of two available SPI buses for the MCP23S09 chips, so we activate half of the active part of the LightBed and simultaneously deactivate the other part.

        The MAX116 module reads data from all MAX11625 chips at once; it also disables other buses when the measurements is in the process. The shortest time to perform measurements of the whole LightBed is $27.2 \cdot 10^{-6}\,s$. The module is aware of the state of MCP23 module. Therefore it can actively perform synchronous detection. The synchronous detection is implemented as periodical measurements of the surrounding light with inactivated all IR LED, and therefore, computing difference from actively controlled measurement.

        We try to utilize ZeroConf protocol to discover high-level servers automatically but sadly, the Harmony framework enables only announce functionality, yet. The ZeroConf protocol is supposed to perform a service location along with the other technologies. We decided to introduce a solution as simple as possible; therefore, we implement a simple subscribe mechanism using \acrshort{UDP} server running on PIC32MZ, which allows high-level servers to announce themselves. Our subscribe server works in \acrfull{LIFO} way with stack size 1, which means always serve only to one server and always to the server who's announcement reach PIC32MZ as last. The server can also unsubscribe themselves and therefore save resources — \acrshort{UDP} client does not know if a message was delivered to the server, so it cannot unsubscribe a server. We measure that the system without running \acrshort{UDP} client can make one measuring iteration in 0.96\,ms, and the system with UDP client running has measuring iteration 1.34\,ms.

        We design our \acrshort{UDP} client in a way that when a small number of messages got lost, the overall result will be still usable, we reach this constraint be sending only part of the system state, instead of sending the whole state in one message. The PIC32MZ \acrshort{MCU} \acrshort{UDP} client sends messages with a length of 130\,bytes; the first byte is Device ID which is reserved byte for future multidevice usage, the second byte is Bank ID, which contains information about active \acrshort{IR} \acrshort{LED} when following data were measured, the rest of the message (128\,bytes) is 16\,bit information from each sensor (\acrshort{LightBed} has 64 \acrshort{IR} phototransistor sensors). The \acrshort{MCU} is sending state continuously; it starts with Bank ID 0 — which is reserved ID for none \acrshort{IR} \acrshort{LED} active, and following to 64 (including). The Bank ID 1 is mapped to an \acrshort{IR} \acrshort{LED} in the top left corner, ID 8 corresponds to the top right \acrshort{IR} \acrshort{LED}, and so on till ID 64 which corresponds to the bottom right \acrshort{IR} \acrshort{LED}. The identification of \acrshort{IR} phototransistors is organized in the same order as \acrshort{IR} \acrshort{LED}.

        The introduction of the \acrshort{UDP} subscribe server, and the client data sender allows us to take advantages of multiple different processing environments with only a slight overhead — we need to implement \acrshort{UDP} server and announce client. However, the \acrshort{UDP} stack is implemented in nearly all thinkable programing languages. Therefore it is only a minor disadvantage.

        We considered several programing languages to select the proper one to implement our high-level server. We took into account C, C++, which are clear languages with solid outputs and with high performance, they may also be a multiplatform solution. We also check the C\# .NET Core which is also a multiplatform framework with high performance, but at the time of development, there were only version 2.2 which is highly suitable for a web server, and cloud solutions, strong support of the desktop application support came in version 3.0 which is in preview stage now. Our next candidate was Python, which is language with the powerful library ecosystem and many data analysis tools, but from mentioned languages, the Python as an interpreted language is slower. And, the last language taken into account was Golang, which is statically typed and compiled language.

        We choose the Golang as it is fast and safe language with multiplatform support. We select project Fyne \cite{cite:fyne}, which is multiplatform \acrshort{GUI}, it builds upon the OpenGL library. We found out during late development that Fyne library has memory leaks for which we did not find a source, we solve this issue by auto restarting our server which handles application memory leaks on the operating system level.

        Our server application is divided into several modules, which respect SOLID principles \cite{cite:solid}, mainly the Single Responsibility Principle, the Liskov Substitution Principle, and the Dependency Inversion Principle — respecting those principles allows us to replace parts of the application with different implementation without harming existing code. Modules we introduce are the LightBed module, the Position Resolver module, and the Transport module, each of those modules is bound by contract definitions allowing global interoperability. The LightBed module contains an implementation of a graphics canvas transforming data from the \acrshort{LightBed} into a simple image containing all available information whose output you can see in the Figure \ref{fig:swCanvas}. The Position Resolver module takes data from \acrshort{LightBed} module and returns the estimated position of the measured item. The Transport module converts data from a data source into the format that the application understands.

        \begin{figure}[!h]
            \includegraphics[width=0.8\textwidth]{SwCanvas.png}
            \caption{Light Bed viewer application}
            \label{fig:swCanvas}
        \end{figure}

        The LightBed viewer shows information about each \acrshort{IR} phototransistor and its influence by an \acrshort{IR} \acrshort{LED}. The image in the application represents $8 \times 8$ matrix with each item containing information in the form of the heat bar on the left side of the cell and heat intensities in the form of the nested $8 \times 8$ matrix in the remaining space of the cell. The heat intensity bar is showing information about surrounding light intensity. The nested matrix shows influence by all \acrshort{IR} \acrshort{LED}s on a single \acrshort{IR} phototransistor, where indexing from the main matrix is the same as in a nested matrices. You can see in the Figure \ref{fig:swCanvas} several blue dots, whose are blacklisted spots as they are affected by the imperfect design of the plastic cover, which should suppress the influence of the light crosstalk mentioned in the previous section.

        We design the LightBed application to be configurable using a configuration file with the name \textit{config.json}. The configuration has a rich structure enabling to configure operation modes of the application; primary to set up the LightBed properties, to configure the data source, and the way of processing the data.

        We support these application data source; the first is a source of random data, which plays the role of a unit test mock. The main data source is the \acrshort{UDP} announce client and the \acrshort{UDP} data server, allowing us to consume live data, which are sent from the \acrshort{LightBed} board. The last data source is the Restoring Data Sourse, which allows us to load and replay stored measurements in real time.
        
        The last not mentioned application module is the Position Resolver module. We created two implementations of the Position Resolver; the first is Storing resolver, which is meta-resolver acting as a counterpart for the Restoring Data Source. The real resolver is so-called Naive Resolver; this resolver implements an algorithm for solving the overdetermined system of linear equations using the least squared method. We will the explain used model in the next section.

        You can see in the Figure \ref{fig:swCanvas} the LightBed application with activated Restoring Transport module, which loads the stored data about the scene — the scene can be seen in the Figure \ref{fig:scene}. The set up on the scene is visible in the application image. You can see near the center of the image an area with a low detection of surrounding light; this is caused by the metal ball on the LightBed board. You can also see several \acrshort{IR} phototransistors detecting reflected light from \acrshort{IR} \acrshort{LED}s, which has a bit higher intensity then reflection from the positioning mechanism connected to the Zaber position device. Also, you can see the position of the ball from the Position Resolver, which is marked as a black dot.

        \begin{figure}[!h]
            \includegraphics[width=1.\textwidth]{scene.jpg}
            \caption{The Light Bed board with testing setup}
            \label{fig:scene}
        \end{figure}

        We implement the \acrshort{UDP} announce client and the \acrshort{UDP} sever in the Python, which has great libraries for data analysis. We created a storing mechanism using the NumPy \cite{cite:numpy} framework. This server allows us to store measurements and add to tag them with values from the Zaber manipulator, which you can see in the Figure \ref{fig:scene}. We are aware that we are searching for a function taking measurements from the LightBed board, which are $65 \times 64$ measurements as a function input, and primary $2 \times 1$ — generally $3 \times 1$ — function output. As we see that a simple linear regression is not enough, and we need multi-output regression \cite{cite:multiOutputRegression}, where we can find a function between mentioned input-output dimensions. We take advantage of the MultiOutputRegressor and \acrfull{SVR} from the scikit-learn \cite{cite:scikit} Python package.

    \section*{Physical model of light rays}
        We found a necessity to create a model which will suit our Navie Position Resolver, mentioned in the previous section. We made several assumptions in the design process of the model. We assume the law of reflection $$
            \theta_o = \theta_i ,
        $$ visualized in the Figure \ref{fig:reflection} \cite{cite:phdThesis}; where the $\theta_i$ is the angle between the surface normal vector $N$ and the incident light ray, and the $\theta_o$ is the angle between the surface normal vector $N$ and the reflected ray. We also assume that the change of the light intensity with distance respects the following equation $$
            L = \dfrac{L_0}{d^2} ,
        $$ visualized in the Figure \ref{fig:lightIntensityWithDistance} \cite{cite:nasaLightIntensity}; where the $L$ is unit light intensity, which means a light intensity at given constant area, the $L_0$ is known light intensity at a known constant area, and the $d$ is the distance between areas. The last assumption is that reflected energy from a shiny ball is not bound with mentioned angles the $\theta_i$ and the $\theta_o$.

        \begin{figure}[!h]
            \includegraphics[width=0.6\textwidth]{reflection.png}
            \caption{The law the reflection}
            \label{fig:reflection}
        \end{figure}

        \begin{figure}[!h]
            \includegraphics[width=0.7\textwidth]{lightIntensityWithDistance.png}
            \caption{Brightness as a Function of Distance}
            \label{fig:lightIntensityWithDistance}
        \end{figure}

        We create the following equation from the given assumptions $$
            \sum_{i=1,2} \sqrt{(x_i-x)^2 + (y_i-y)^2}^2 = \dfrac{L_0}{L} ,
        $$ where the $[x_1, y_1]$ are the real world coordinates of the \acrshort{IR} \acrshort{LED} (the emitter), the $[x_2, y_2]$ are the real world coordinates of the \acrshort{IR} phototransistor (the transceiver), and the $[x, y]$ are unknown coordinates of the measured item.

        We do not know the value $L_0$, but we assume that we can derive it from the maximal measured values between the emitters and the transceivers. We create this equation to estimate $L_0$ $$
            L_0 = \dfrac{L_{max}}{ \sqrt{(x_1-x_2)^2 + (y_1-y_2)^2}^2 } .
        $$
        
        We know now all properties of the system, expect the $[x, y]$. We assume that there are no complex distances in the system. Therefore we can simplify the equation of the model to $$
            \sum_{i=1,2} (x_i-x)^2 + (y_i-y)^2 = \dfrac{L_0}{L} ,
        $$ which we can linearize using the Taylor expansion. The model needs to be linearized so that we can use it in our overdetermined system solver mentioned in the previous section.

        The Taylor expansion for the distance in our model has the following coefficients \begin{align*}
            T_0: & f(a_x, a_y) = 2a_x^2 + 2a_y^2 + x_1^2 + x_2^2 - 2a_x(x_1 + x_2) - 2a_y(y_1 + y_2) + y_1^2 + y_2^2 \\
            T_{1x}: & f(a_x, a_y) = 4a_x - 2(x_1 + x_2) \\
            T_{1y}: & f(a_x, a_y) = 4a_y - 2(y_1 + y_2) \\
            T_{2xx}: & f(a_x, a_y) = 4 \\
            T_{2xy}: & f(a_x, a_y) = 0 \\
            T_{2yy}: & f(a_x, a_y) = 4 ,
        \end{align*} where $[a_x, a_y]$ are coordinates of the initial conditions. The whole expansions if the $d$ is \begin{align*}
            d & = T_0(a_x, a_y) \\ & 
            + (x - a_x)T_{1x}(a_x, a_y) + (y - a_y)T_{1y}(a_x, a_y) \\ & 
            + \dfrac{1}{2!}(x - a_x)^2T_{2xx}(a_x, a_y) \\ &
            + \dfrac{1}{2!}(x - a_x)(y - a_y)T_{2xy}(a_x, a_y) \\ &
            + \dfrac{1}{2!}(y - a_y)^2T_{2yy}(a_x, a_y) .
        \end{align*} where we can see non-linearity from the second order Taylor expansion. Therefore we will use only the constant and the first items from Taylor series in our overdetermined system solver.

        The overdetermined system solver solves the following equation \cite{cite:overdetermined} $$
            \boldsymbol{A} \vec{x} = \vec{b} , 
        $$ where rows of the matrix $\boldsymbol{A}$ are $$
            \vec{A_i} = \begin{bmatrix}  4a_x - 2x_1 - 2x_2 & 4a_y - 2y_1 - 2y_2 \end{bmatrix} ,
        $$ the column vector $\vec{x}$ consist of unknown coordinates $[x, y]$, and elements of the vector $\vec{b}$ are \begin{align*}
            b_i & = \dfrac{L_0}{L} - 2a_x^2 + 2a_y^2 + x_1^2 + x_2^2 - 2a_x(x_1 + x_2) - 2a_y(y_1 + y_2) + y_1^2 + y_2^2 \\ &
            + a_x(4a_x-2x_1-2x_2) + a_y(4a_y-2y_1-2y_2) .
        \end{align*}

        Since the matrix $\boldsymbol{A}$ does not have dimension $n \times n$, but rather $m \times n$ we cannot compute regular $\boldsymbol{A}^{-1}$. However, there is a solution called pseudoinverse of a matrix detoned \textit{$pinv(\boldsymbol{A})$} or $\boldsymbol{A}^{\dagger}$. This pseudoinverse can be computed as follows $$
            \boldsymbol{A}^{\dagger} = \left( \boldsymbol{A}^{T} \boldsymbol{A} \right)^{-1} \boldsymbol{A}^{T} .
        $$

        From the fact we can compute pseudoinverse matrix, we can derive the solution for vector $\vec{x}$ $$
            \vec{x} = \boldsymbol{A}^{\dagger} \vec{b} .
        $$ Computation of the solution is the product of matrix multiplication from measured values and known information about the position of \acrshort{IR} phototransistors and \acrshort{IR} \acrshort{LED}s on the \acrshort{LightBed}.

    \section*{Distributed Communication}
        We do not propose a solution actively supporting distributed operations, but we kept in mind that the solution should be ready for a distributed environment. The \acrshort{MCU} has a spare computation capacity and free \acrshort{I2C} buses, which should guarantee a possibility for connecting multiple position sensors.

\chapter{Experiments}
    This chapter will describe the experiments we made. We made several tests and verifications. One of the experiments we made was the first revision of the LightBed board; we made simultaneous experiments regarding the LightBed transceivers and emitters and the following circuits. In the next stage, we tested proper functions of the LightBed board, Ethernet port, used protocols, data conversion, and response time of developed solutions. We also designed 3D ray tracing simulator, where we can test new models. We also implemented storing mechanisms in designed applications so we can compare different model configuration on the same data set.

    \section*{The first LightBed board revision}
        The first hardware revision did not work as we planned, but we take note about what should be improved.
        
        The first issue we discovered was the zero support of the \acrshort{SPI} Daisy-Chain in the \acrshort{ADC} and \acrshort{IO} expander chips, which was not clear from datasheets. The Daisy-Chain issue made \nicefrac{3}{4} of the LightBed board unreachable or not fully controllable. By solving the Daisy-Chain issue, we did simplify the controlling protocol and increase the throughput of chips.
        
        The second issue we discovered was too low available current on the output pin in the HIGH state of the \acrshort{IO} expander chip, which was not high enough to open originally used NPN transistor, which we used to activate the \acrshort{IR} \acrshort{LED}.

        The third issue we discovered was not the optimal value of the resistor in series with an \acrshort{IR} phototransistor. The resistor value was designed as too low. Therefore circuits became saturated with lower light intensity than was optimal.

        The last issue we discovered on the first LightBed revision was direct light crosstalk between \acrshort{IR} \acrshort{LED} and \acrshort{IR} phototransistor. We partially suppress the effect of the light crosstalk by creating a 3D-printed plastic cover. We change the position of parts in the next generation of the LightBed board so the plastic cover can achieve a bigger efficiency.

    \section*{The LightBed emitters and transceivers}
        We learned a lesson from the first failure — which was originally a proof of concept solution — and we create two types of testing boards with only one \acrshort{ADC} and following circuits, and with one \acrshort{IO} expander and following circuits. We use these testing boards for creating and optimization of the \acrshort{MCU} drivers. We also tested circuits changes proposed in the previous section.

    \section*{Functionality tests}
        We did power up the final revision of the LightBed board. This revision does not contain known hardware issues, expect the possibility of crosstalk between \acrshort{SPI} buses. The crosstalk issue arises when we started to communicate with the all LightBed board parts at once; we suppress the crosstalk issue by introducing a serial resistor on problematic buses.
        
        Since communication issues were solved, we were able to measure the performance of the system parts. We measured the time of one measurement iteration, which consists of configuring the outputs on IO expanders, and reading measurements from all ADCs. The measurement iteration time iteration is different when the UDP sender is active (some server is subscribed), and when it is inactive. The iteration time for inactive UDP sender is $0.98 \cdot 10^{-3}\,s$, and for active UDP sender is $1.23 \cdot 10^{-3}\,s$. Measurements were averaged in 64 iterations, in this window size is updated the whole LightBed state. We also measured a frequency of messages reaching the UDP server, the frequency is measured per one second, and for one second is 130\,messages/s.

        We also checked that the UDP sender and the UDP server have the same endian format. Therefore, the transported information is interpreted as the same value on the UDP sender and the UDP server.

    \section*{Simulator}
        We implemented 3D ray tracing simulator in the Python. We used the library Pvtrace \cite{cite:pvtrace}, which allows 3D visualization of a photon, and it handles reflection and refraction in the correct way. We created a simple demonstration of reflection with one IR LED source in the scene containing one reflective sphere; you may see the demonstration in the Figure \ref{fig:pvtrace} and its propagation on the virtual LightBed in the Figure \ref{fig:simulatedLightBed}, where is the light source in the position $[0.4, 0.4, 0.1]$, and the sphere of radius $0.3$ in the position $[0.5, 0.5, 0.4]$.

        \begin{figure}[!h]
            \includegraphics[width=1.\textwidth]{pvtraceSim.png}
            \caption{3D Simulation of the LightBed using pvtrace library}
            \label{fig:pvtrace}
        \end{figure}

        \begin{figure}[!h]
            \includegraphics[width=1.\textwidth]{pvtraceToPlane.png}
            \caption{Simulation of light rays from the 3D scene into the plane}
            \label{fig:simulatedLightBed}
        \end{figure}

        We did not use simulation more extensively because the computing of light rays using the selected library is precise but slow in comparison to storing and replacing real data from the LightBed.

        %% TODO coordinates of the simulation

    \section*{Measurements storing}
        Parts of the LightBed viewer are Storing Position Resolver and Restoring Data Source modules. We used these modules to store real-world data from the LightBed board, and to run on them Position Resolver with different parameters. We did run Position Resolver with plenty of different parameters of the model; where parameters are the number of IR phototransistors used (values are sorted in descending order), count of IR LEDs used, and iterations of the overdetermined position resolver. Even we use plenty of resolver configuration; the output was always highly affected by noise, which made a computation of error rates not reliable. We compared the measured data for several sizes of metal balls (see Figure \ref{fig:balls}); the bigger shiny ball were noticeable, and distinguishable from the manipulator in the LightBed viewer.

        \begin{figure}[!h]
            \includegraphics[width=1.\textwidth]{balls.jpg}
            \caption{4 metal balls used in experiments}
            \label{fig:balls}
        \end{figure}

\chapter{Discussion and Conclusion}
    This chapter will mention ways of possible future developments.

    The next steps can be made in developing new ways how the position is estimated, especially the ones which resolves position in the desired accuracy. The accuracy can be improved using neural networks.

    The other direction of improvements can be made in introducing 3D position resolvers, which should work well with a proper model.

    An interesting theme is also recognition of type and structure of measured items with the power of neural networks.

    We designed the system which constantly measures the surrounding environment light intensities; it lights the measured scene with controlled IR LEDs of the known position. The system uses synchronous detection so it can suppress the effect of the surrounding light. It consists of the LightBed board, the microcontroller PIC32MZ, Ethernet interface, and server application. The final solution is in Figures \ref{fig:lightBedTop} and \ref{fig:lightBedBottom}, this solution is ready for the distributed environment, and it is also distributed internally.

    The proposed solution is working solution from the perspective of designed hardware, which should be able to measure data necessary to resolve the position of the measured items. However, we were not successful in building a model to do so. You can see the whole solution in action on videos attached on the CD.